#ifndef _E_FILESEL_H_
#define _E_FILESEL_H_

#include <gtk/gtkdialog.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define E_TYPE_FILESEL (e_filesel_get_type ())
#define E_FILESEL(obj) (GTK_CHECK_CAST ((obj), E_TYPE_FILESEL, EFileSel))
#define E_FILESEL_CLASS(klass) (GTK_CHECK_CLASS_CAST ((klass), E_TYPE_FILESEL, EFileSelClass))
#define E_IS_FILESEL(obj) (GTK_CHECK_TYPE ((obj), E_TYPE_FILESEL))
#define E_IS_FILESEL_CLASS(obj) (GTK_CHECK_CLASS_TYPE ((klass), E_TYPE_FILESEL))
#define E_FILESEL_GET_CLASS(obj) (GTK_CHECK_GET_CLASS ((obj), E_TYPE_FILESEL, EFileSelClass))

  typedef struct _EFileSel EFileSel;
  typedef struct _EFileSelClass EFileSelClass;
  typedef struct _EFileSelPrivate EFileSelPrivate;

  struct _EFileSel {
    GtkWindow parent_window;

    EFileSelPrivate * priv;
  };

  struct _EFileSelClass {
    GtkWindowClass parent_class;

    void (*response) (EFileSel * filesel, gint response_id);

    /* Padding for future expansion */
    void (*_e_reserved1) (void);
    void (*_e_reserved2) (void);
    void (*_e_reserved3) (void);
    void (*_e_reserved4) (void);
  };

  GType e_filesel_get_type (void) G_GNUC_CONST;

  GtkWidget * e_filesel_new (gboolean save_dialog);

  void e_filesel_set_filename (EFileSel * filesel,
			       const gchar * filename);
  void e_filesel_set_dirname (EFileSel * filesel,
			      const gchar * dirname);

  gchar * e_filesel_get_filename (EFileSel * filesel);

  void e_filesel_append_filter (EFileSel * filesel,
				const gchar * filter_name,
				const gchar * filter_type);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _E_FILESEL_H_ */
